/*

Scrivere un programma per la gestione dei clienti di un negozio e degli acquisti dei prodotti. 
I clienti sono caratterizzati dalle seguenti informazioni: cognome, nome, codice cliente, categoria cliente (0=privati, 1=business, 2= premium).
Gli acquisti sono caratterizzati dalle seguenti informazioni: codice cliente, codice prodotto, importo prodotto, tipo prodotto (0..5).
I clienti sono inseriti in un vettore di 3 liste, una per ogni categoria di cliente. 
Gli acquisti sono inseriti in una tabella allocata dinamicamente avente 6 righe, una  per tipo di prodotto.

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1. Inserimento  nel vettore di liste di una nuovo cliente; 
2. Eliminazione di un cliente da una lista dopo la sua visualizzazione (chiedere la categoria);
3. Inserimento di una nuovo acquisto;
4. Visualizzazione degli acquisti ;
5. Salvataggio su file degli acquisti relativi a un cliente (chiedere il codice cliente);

All'avvio del programma inizializzare la tabella degli acquisti leggendo da file gli acquisti  precedentemente salvati.

Liberare la memoria allocata dinamicamente.

*/



#include <stdio.h>
#include <stdlib.h>
struct cliente
{
       char cognome[20];
       char nome[30];
       long codice;
       int categoria;
};
struct atomo
{
       struct cliente dato;
       struct atomo *next;
};
struct acquisto
{
       long cliente;
       long prodotto;
       float importo;
       int tipo_prodotto;
};

void da_testa(struct atomo **ptl);
void leggi_cliente(struct cliente *c);
void inserisci_cliente(struct atomo *L[3]);
void elimina_cliente(struct atomo *L[3]);
void leggi_acquisto(struct acquisto *l);
void inserisci_acquisto(struct acquisto **T,int *n,struct acquisto l);
void visualizza_acquisti(struct acquisto *T[6],int N[6]);
void salva_su_file(struct acquisto *T[6],int N[6]);
void inizializza(struct acquisto *T[6],int N[6]);

main()
{
      struct atomo *L[3];
      struct acquisto *T[6],l;
      int N[6],scelta,i;
      for(i=0;i<3;i++)
           L[i]=NULL;
      for(i=0;i<6;i++)
      {
          T[i]=NULL;
          N[i]=0;
      }
      
      inizializza(T,N);
      
      do{
         printf("Scegli tra: \n");
         printf("1)Inserisci un nuovo cliente\n");
         printf("2)Elimina un cliente dopo averlo visualizzato\n");
         printf("3)Inserisci un nuovo acquisto\n");
         printf("4)Visualizza acquisti\n");
         printf("5)Salva su file gli acquisti relativi a un cliente\n");
         printf("0)Termina l'applicazione\n");
         scanf("%d",&scelta);
         switch(scelta)
         {
                       case 1: inserisci_cliente(L);
                               break;
                       case 2: elimina_cliente(L);
                               break;
                       case 3: leggi_acquisto(&l);
                               i=l.tipo_prodotto;
                               inserisci_acquisto(&T[i],&N[i],l);
                               break;
                       case 4: visualizza_acquisti(T,N);
                               break;
                       case 5: salva_su_file(T,N);
                               break;
         }
         }while(scelta!=0);
        
        /* Liberazione della memoria allocata dinamicamente */
        
         for(i=0;i<3;i++)
            while(L[i]!=NULL)
              da_testa(&L[i]);
              
         for(i=0;i<6;i++)
         free(T[i]);
}




void da_testa(struct atomo **ptl)
{
     struct atomo *a;
     a=*ptl;
     *ptl=a->next;
     free(a);
}

void leggi_cliente(struct cliente *c)
{
     printf("Cognome: ");
     scanf("%s",c->cognome);
     printf("Nome: ");
     scanf("%s",c->nome);
     printf("Codice cliente: ");
     scanf("%ld",&c->codice);
     printf("Categoria cliente: ");
     scanf("%d",&c->categoria);
}

void inserisci_cliente(struct atomo *L[3])
{
     struct cliente c;
     struct atomo *a;
     int i;
     
     a=malloc(sizeof(struct atomo));
     if(a==NULL)
     return;
     
     leggi_cliente(&c);
     i=c.categoria;
     a->dato=c;
     a->next=L[i];
     L[i]=a;
}

void elimina_cliente(struct atomo *L[3])
{
     int i;
     long codice;
     struct atomo *l1,*l2;
     printf("Categoria del cliente da eliminare: ");
     scanf("%d",&i);
     printf("Codice del cliente da eliminare: ");
     scanf("%ld",&codice);
     
     if(L[i]==NULL)
     {
                   printf("Lista vuota\n");
                   return;
     }
     if(codice==L[i]->dato.codice) /* trovato in testa */
     {
                                  printf("\nCognome: %s\n",L[i]->dato.cognome);
                                  printf("Nome: %s\n\n",L[i]->dato.nome);
                                  da_testa(&L[i]);
                                  return;
     }
     l1=L[i]->next;
     l2=L[i];
     while(l1!=NULL)
     if(codice==l1->dato.codice)
     {
                                l2->next=l1->next;
                                printf("\nCognome: %s\n",l1->dato.cognome);
                                printf("Nome: %s\n\n",l1->dato.nome);
                                free(l1);
                                return;
     }
     else{
          l2=l2->next;
          l1=l1->next;
          }
          printf("Cliente non trovato\n");
}

void leggi_acquisto(struct acquisto *l)
{
     printf("Codice cliente: ");
     scanf("%ld",&l->cliente);
     printf("Codice prodotto: ");
     scanf("%ld",&l->prodotto);
     printf("Importo prodotto: ");
     scanf("%f",&l->importo);
     printf("Tipo prodotto: ");
     scanf("%d",&l->tipo_prodotto);
}
void inserisci_acquisto(struct acquisto **T,int *n,struct acquisto l)
{
     struct acquisto *a;
     
     a=realloc(*T,(*n+1)*sizeof(struct acquisto));
     if(a==NULL)
     return;
     *T=a;
     (*T)[*n]=l;
     (*n)++;
}
void visualizza_acquisti(struct acquisto *T[6],int N[6])
{
     int tipo,j;
       
     
   
     for(tipo=0;tipo<6;tipo++)
         for(j=0;j<N[tipo];j++)
             {
                printf("\nCodice prodotto: %ld\n",T[tipo][j].prodotto);
                printf("Importo prodotto: %f\n",T[tipo][j].importo);
                printf("Tipo prodotto: %d\n\n",T[tipo][j].tipo_prodotto);
             }
}


void salva_su_file(struct acquisto *T[6],int N[6])
{
     FILE *pf;
     int i,tipo;
     long cliente;
     printf("Codice cliente: ");
     scanf("%ld",&cliente);
     pf=fopen("acquisti.txt","w");
     if(pf!=NULL)
     {
                 for(tipo=0;tipo<6;tipo++)
                   for(i=0;i<N[tipo];i++)
                      if( T[tipo][i].cliente==cliente)
                          fwrite(&T[tipo][i],sizeof(struct acquisto),1,pf);
                 fclose(pf);
     }
     else printf("Errore in scrittura\n");
}
void inizializza(struct acquisto *T[6],int N[6])
{
     FILE *pf;
     struct acquisto temp;
     int i;
     pf=fopen("acquisti.txt","r");
     if(pf!=NULL)
     {
                 while(fread(&temp,sizeof(struct acquisto),1,pf)>0)
                 {
                                                 i=temp.tipo_prodotto;
                                                 inserisci_acquisto(&T[i],&N[i],temp);
                 }
                 fclose(pf);
     }
     else printf("Errore: il file non esiste\n");
}

